/*
 * ACB-BF592 SPI FLASHANZXR[h(|[O)
 *
 * Copyright(C) 2012 Kaneko System Co., Ltd.
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <string.h>

/* VXeNbN(100MHz) */
#define SCLOCK_HZ			(100000000)

/* SPI FLASH MEMORY R}h */
#define FLASH_CMD_WREN		(0x06)	/* Write Enable */
#define FLASH_CMD_WRDI		(0x04)	/* Write Disable */
#define FLASH_CMD_RDID		(0x9F)	/* Read Identification */
#define FLASH_CMD_RDSR		(0x05)	/* Read Status Register */
#define FLASH_CMD_WRSR		(0x01)	/* Write Status Register */
#define FLASH_CMD_READ		(0x03)	/* Read Data bytes */
#define FLASH_CMD_FAST_READ	(0x0B)	/* Read Data bytes at higher speed */
#define FLASH_CMD_PP		(0x02)	/* Page Program */
#define FLASH_CMD_SE		(0xD8)	/* Sector Erase */
#define FLASH_CMD_BE		(0xC7)	/* Bulk Erase */
#define FLASH_CMD_DP		(0xB9)	/* Deep Power-down */
#define FLASH_CMD_RES		(0xAB)	/* Release from Deep Power-down */
#define FLASH_CMD_STS_WIP	(0x01u)	/* Status Register Write In Progress bit */

#define FLASH_PAGE_SIZE     (256)	/* 1y[W̃oCgTCY */

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

static void s_spi0_init(void)
{
	/*****************************************************************************
	 * |[g
	 * SPI_SSEĹASPIł͂ȂAGPIOŐ䂵܂B
	 * MODE 0̏ꍇA]Ƀ[hPʂSSELωA'L'ɌŒłȂ߂łB
	 * SPÎ̎dlȂ̂Ǝv܂B
	 * 
	 * SPI0 - tbV|[g}bsO
	 * Blackfin          Flash
	 * PF8(SPI0_SSEL2) - CS(1ԃs)
	 * PF13(SPI0_MOSI) - DI(5ԃs)
	 * PF14(SPI0_MISO) - DO(2ԃs)
	 * PF15(SPI0_SCK)  - SCK(6ԃs)
	 ****************************************************************************/
	*pPORTF_FER   &= ~PF8;
	*pPORTFIO_SET  = PF8;
	*pPORTFIO_DIR |= PF8;
	/* SPI SCK, MOSI, MISO */
    *pPORTF_FER   |= PF13 | PF14 | PF15;
    *pPORTF_MUX   &= ~(PF13 | PF14 | PF15);
	/* SPI */
	*pSPI0_BAUD    = 2;	/* 25MHz(MAX) */
	*pSPI0_CTL     = SPE | MSTR | EMISO | TDBR_CORE;
	*pSPI0_FLG     = 0;
	ssync();
}

/* SPIʐMJn(SPI SSEL2s'L'ɕύX) */
static void s_spi0_flash_assert(void)
{
	*pPORTFIO_CLEAR = PF8;
	ssync();
	/* SSELAT[g̃fBC(10ns) 1 cylce = 1/400Mhz = 2.5ns */
	/* ڍׂ́AtbṼf[^V[gQ */
	NOP();
	NOP();
	NOP();
	NOP();
}

/* SPIʐMI(SPI SSEL2s'H'ɕύX) */
static void s_spi0_flash_deassert(void)
{
	int32_t l_lc;

	*pPORTFIO_SET = PF8;
	ssync();
	/* SSELfAT[g̃fBC(100ns) 1 cylce = 1/400Mhz = 2.5ns */
	/* ڍׂ́AtbṼf[^V[gQ */
	for(l_lc = 0; l_lc < (100 / 2.5); l_lc++) NOP();
}

/* SPI 1oCg] */
static uint8_t s_spi0_xfer(uint8_t send_data)
{
	/* Mf[^ݒ肵A]Jn */
	*pSPI0_TDBR = send_data;
	ssync();
	/* ]܂őҋ@ */
	while((*pSPI0_STAT & RXS) == 0) ssync();

	/* Mf[^擾 */
	return *pSPI0_RDBR;
}

/* tbṼf[^ǂݏo */
static void s_spi0_flash_data_read(uint32_t flash_addr, void* p_buf, int32_t byte_count)
{
	int32_t  l_lc;
	uint8_t* lp_read_buf = (uint8_t*)p_buf;
	
	if(byte_count <= 0)
		return;
	
	/* SPI0]Jn */
	s_spi0_flash_assert();

	/* R}hM */
	s_spi0_xfer(FLASH_CMD_READ);
	/* AhXM */
	s_spi0_xfer(flash_addr >> 16);
	s_spi0_xfer(flash_addr >> 8);
	s_spi0_xfer(flash_addr);
	
	/* f[^[h */
	for(l_lc = 0; l_lc < byte_count; l_lc++)
	{
		lp_read_buf[l_lc] = s_spi0_xfer(0);
	}

	/* SPI0]I */
	s_spi0_flash_deassert();
}

/* tbVɏ݋R}h𑗂 */
static void s_spi0_flash_write_enable(void)
{
	/* SPI0]Jn */
	s_spi0_flash_assert();
	/* ݋ */
	s_spi0_xfer(FLASH_CMD_WREN);
	/* SPI0]I */
	s_spi0_flash_deassert();
}

/* ݏI܂őҋ@ */
static void s_spi0_flash_wait_for_write(void)
{
	/* SPI0]Jn */
	s_spi0_flash_assert();

	/* R}hM */
	s_spi0_xfer(FLASH_CMD_RDSR);

	/* WIPrbg0ɂȂ܂őҋ@ */
	while((s_spi0_xfer(0) & FLASH_CMD_STS_WIP) != 0) ssync();

	/* SPI0]I */
	s_spi0_flash_deassert();
}

/* tbVւ̃f[^݁iy[WPʁj*/
/* OɃy[WĂ邱 */
static void s_spi0_flash_page_write(uint32_t flash_addr, const uint8_t* p_buf, int32_t byte_count)
{
	int32_t l_lc;
	const uint8_t* lp_write_buf = (const uint8_t*)p_buf;
	
	/* ݋ */
	s_spi0_flash_write_enable();
	
	/* SPI0]Jn */
	s_spi0_flash_assert();

	/* R}hM */
	s_spi0_xfer(FLASH_CMD_PP);
	/* AhXM */
	s_spi0_xfer(flash_addr >> 16);
	s_spi0_xfer(flash_addr >> 8);
	s_spi0_xfer(flash_addr);
	
	/* f[^Cg */
	for(l_lc = 0; l_lc < byte_count; l_lc++)
	{
		s_spi0_xfer(lp_write_buf[l_lc]);
	}

	/* SPI0]I */
	s_spi0_flash_deassert();
	
	/* ݏI܂őҋ@ */
	s_spi0_flash_wait_for_write();
}

/* tbVւ̃f[^ */
/* OɃy[WĂ邱 */
static void s_spi0_flash_data_write(uint32_t flash_addr, const uint8_t* p_buf, int32_t byte_count)
{
	int32_t  l_lc;
	uint32_t l_write_size;
	const uint8_t* lp_write_buf = (const uint8_t*)p_buf;

	/* ݃TCY擾() */
	l_write_size = FLASH_PAGE_SIZE - (flash_addr & (FLASH_PAGE_SIZE - 1));
	while(byte_count > 0)
	{
		/* c菑݃TCYXV */
		byte_count -= l_write_size;
		/* y[W */
		s_spi0_flash_page_write(flash_addr, lp_write_buf, l_write_size);
		/* AhXXV */
		flash_addr += l_write_size;
		lp_write_buf = &lp_write_buf[l_write_size];
		/* ̏݃TCY擾 */
		l_write_size = byte_count >= FLASH_PAGE_SIZE ? FLASH_PAGE_SIZE : byte_count;
	}
}

/* wAhX̃ZN^ */
static void s_spi0_flash_sector_erase(uint32_t flash_addr)
{
	/* ݋ */
	s_spi0_flash_write_enable();

	/* SPI0]Jn */
	s_spi0_flash_assert();

	/* R}hM */
	s_spi0_xfer(FLASH_CMD_SE);
	/* AhXM */
	s_spi0_xfer(flash_addr >> 16);
	s_spi0_xfer(flash_addr >> 8);
	s_spi0_xfer(flash_addr);
	
	/* SPI0]I */
	s_spi0_flash_deassert();
	
	/* ݏI܂őҋ@ */
	s_spi0_flash_wait_for_write();
}

static uint8_t sf_buf0[1024];
static uint8_t sf_buf1[1024];

void main(void)
{
	int32_t l_lc;
	int32_t l_failed;
	
	/* PLLݒ */
	s_bfin_clk_pll_set(16, 4);

	/* SPI0 */
	s_spi0_init();
	
	l_failed = 0;
	
	/***********************************************************************
	 * ZN^eXg
	 ***********************************************************************/
	/* ZN^(AhX0x000000 = ZN^ԍ0) */
	s_spi0_flash_sector_erase(0x000000);
	/* ǂݍ */
	s_spi0_flash_data_read(0x000000, sf_buf1, sizeof(sf_buf1));
	memset(sf_buf0, 0xFF, sizeof(sf_buf0));
	/* r */
	if(0 != memcmp(sf_buf0, sf_buf1, sizeof(sf_buf0)))
	{
		/* s */
		l_failed++;
	}
	
	/***********************************************************************
	 * ݃eXg
	 ***********************************************************************/
	/* _~[f[^ݒ */
	for(l_lc = 0; l_lc < sizeof(sf_buf0); l_lc++)
	{
		sf_buf0[l_lc] = (uint8_t)l_lc;
	}

	/*  */
	s_spi0_flash_data_write(0x000003, sf_buf0, sizeof(sf_buf0));
	/* ǂݍ */
	s_spi0_flash_data_read(0x000003, sf_buf1, sizeof(sf_buf1));
	
	/* r */
	if(0 != memcmp(sf_buf0, sf_buf1, sizeof(sf_buf0)))
	{
		/* ݎs */
		l_failed = -1;
	}
}
